;=========================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;=========================
;Antfarm Routine
;Greg Harder, 2024
;=========================

@DFile=400C
@Vars=4010
@Bank0=2000
@FarmScr=3C00
@WhiteChr=+16381
@BlackChr=+16382
@SandChr=+16383

ORG 5014		;20500

;================================
; Jump Table
;================================
	JR Up		;20500
	JR Down		;20502
	JR Left		;20504
	JR Rite		;20506
	JR Sand		;20508
	JP Invert	;20510
	JR LoadFarm	;20513
	JP Convert	;20515
;================================
; Load screen
;================================
@LoadFarm
	LD HL,FarmScr		;Set source, Saved screen
	LD DE,(DFile)		;Get DFile
	LD BC,0319		;BC=byte count
	LDIR			;Copy source to desination
	RET			;Return 0 to BASIC
;=========================
; 8 Way Scrolls
;=========================
@Up
	LD HL,(DFile)
	PUSH HL 
	LD DE,0021 
	ADD HL,DE 
	POP DE 
	LD BC,02F7 
	LDIR 
	LD DE,0021 
	SBC HL,DE 
	JR Erase
;==========================
@Down
	LD HL,(Vars)
	DEC HL 
	PUSH HL 
	LD DE,0021 
	SBC HL,DE 
	POP DE 
	LD BC,02F7 
	LDDR 
	LD HL,(DFile)
@Erase
	LD B,20 
	INC HL 
@Sand1
	LD (HL),00 
	DJNZ -5
	RET			;Return 0 to BASIC
;==========================
@Left
	LD HL,(DFile)
	LD DE,0318 
	ADD HL,DE 
	LD B,18 
@Left1
	DEC HL 
	LD C,(HL) 
@Sand2
	LD (HL),00 
@Left2
	DEC HL 
	LD A,(HL) 
	CP 76 
	JR Z +2
	JR +4
	DJNZ Left1
	JR Ret0
	LD (HL),C 
	LD C,A 
	JR Left2
;==========================
@Rite
	LD HL,(DFile)
	LD B,18 
@Rite1
	INC HL 
	LD C,(HL) 
@Sand3
	LD (HL),00 
@Rite2
	INC HL 
	LD A,(HL) 
	CP 76 
	JR Z +2
	JR +4
	DJNZ Rite1
	JR Ret0
	LD (HL),C 
	LD C,A 
	JR Rite2
;==================================
; Replace Chr D with Chr E
;==================================
@Sand
	LD A,(SandChr)		;Get sand chr
	LD (Sand1+1),A		;Set scroll sand chr
	LD (Sand2+1),A		;Set scroll sand chr
	LD (Sand3+1),A		;Set scroll sand chr
	LD D,00			;Replace " "
	LD E,A			;With sand chr
	LD BC,1800 		;B=Row counter, 24
	LD HL,(DFile)		;Get DFile
@SandLup
	INC HL 
	LD A,(HL)		;Get current DFile chr
	CP 76	 		;N/L test
	JR Z +6
	CP D			;Find this Chr.
	JR NZ SandLup
	LD (HL),E		;And replace it with E
	JR SandLup
	DJNZ SandLup
	RET			;Return 0 to BASIC
;============================
;Invert the display
;============================
@Invert
	LD HL,Bank0		;Bank0 base address
@InvLoop
	LD A,(HL)		;Get UDG data
	CPL			;Invert data
	LD (HL),A		;Replace UDG data
	INC HL			;Next UDG address
	LD A,24			;EOF test
	CP H
	JR NZ InvLoop
@Ret0
	LD BC,0000		;Return 0 to BASIC
	RET
;==================================
;Convert 
;==================================
@Convert
	LD DE,(WhiteChr)	;D=Black cell, E=White cell
	LD HL,(DFile)		;Get start of DFile
	LD BC,0319		;Byte count
@ConLoop
	LD A,(HL)		;Get current DFile chr
	BIT 6,A			;N/L test
	JR NZ Skip		;Skip over N/L chr
	CP (IY-1)
	JR Z Skip		;Skip over sand chr
	AND A
	JR Z Skip		;Skip over white space
	BIT 7,A			;Black chr test
	JR Z +3			;Jump if white chr
	LD (HL),D		;Replace black chr with black cell
	JR +1
	LD (HL),E		;Replace white chr with white cell
@Skip
	INC HL			;Next DFile address
	DEC BC			;Decrease counter
	LD A,B 
	OR C 
	JR NZ ConLoop		;Loop until BC=0
	RET